module fib

contains

  integer function fib_fun(n)

    integer, intent(in) :: n
    integer :: fn, fnm1
    integer :: i

    fib_fun = 0
    if (n == 0) return
    
    fib_fun = 1
    if (n == 1) return
    
    fnm1 = 0
    fn = 1
    do i=2, n
      fib_fun = fn + fnm1
      if(fn > huge(0) - fnm1) then
          write(0,*) 'Index :',n, 'too much for the result to fit in integer type'
          fib_fun = huge(0)
          return
      endif
      fnm1 = fn
      fn = fib_fun
    enddo

  end function fib_fun

end module fib

program main_fib

   use fib

   integer :: n,fn

   write(*,*) 'Insert Fibonacci number index (beware of the overflow!)'
   read(*,*) n
   fn = fib_fun(n)
   if(fn < huge(0)) then 
     write(*,*) 'The ',n,'-th Fibonacci number is: ',fn
   else
     write(*,*) 'Error in function fib_fun'
   endif

end program main_fib
