! Implement the primenumbers research algorithm using numbertheory
program findprimenumbers

  use numbertheory

  implicit none
  integer, parameter :: n=1000000
  integer :: upper, howmany
  integer :: i, j, last

  write(*,*) 'Enter an upper limit <= ', n
  read(*,*) upper

  howmany = 0
  do i = 2, upper
     j = 2
     last = sqrt(real(i)) + 1
     do while ( (j<last) .and. gcd(i,j) /= j ) 
        j = j + 1
     enddo
     if (j==last) then
       print *,'i = ',i
       howmany = howmany+1 
     endif
  enddo     

  write(*,*) 'Found ', howmany, 'prime numbers'

end program findprimenumbers
